package edu.berkeley.sbp.chr;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.lang.ref.*;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.util.*;
import edu.berkeley.sbp.misc.*;
import edu.berkeley.sbp.Input.Location;

public class CharParser extends Parser<Character,String> {

    public Forest<String> parse(InputStream is) throws IOException, ParseFailed { return super.parse(new CharInput(is)); }
    public Forest<String> parse(Reader r)       throws IOException, ParseFailed { return super.parse(new CharInput(r)); }

    public CharParser(Union u) { super(u, new CharTopology()); }

    public Forest<String> shiftToken(Location oldloc, Character ct, Location newloc) {
        return Forest.create(new Input.Region(oldloc, newloc), ct.toString(), null, false);
    }

}
